import pyopencl as cl
platforms = cl.get_platforms()

# pick out the ATI platform
platform = None
for p in platforms:
    if 'ATI' in p.get_info(cl.platform_info.NAME):
        platform = p
        break
    if platform is None:
        raise RuntimeError, "No ATI platform found."

#devices = p.get_devices(device_type=cl.device_type.CPU)
devices = p.get_devices(device_type=cl.device_type.DEFAULT)

num_device = 0
d = devices[num_device]

def get_device_properties(d):
    import re

    p = re.compile('^[A-Z_]+$')
    props = {}
    for prop,propid in cl.device_info.__dict__.iteritems():
        if p.match(prop):
            props[prop] = d.get_info(propid)
    return props
    

print "Found device: %s" % str(d)

props = get_device_properties(d)

for k,v in props.iteritems():
    print "%s :\t\t%s" % (k,v)

ctx = cl.Context(devices=[d])


